<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en">
<head>
	<title>CarbonPHP Documentation</title>
	<style type="text/css">
		* {
			margin: 0;
			padding: 0;
		}

		html {
			font-family: "Lucida Sans Unicode", "Lucida Grande";
			font-size: 14px;
		}

		body {
			background: #fff;
			color: #666;
		}

		h1 {
			font-size: 15px;
			font-weight: bold;
			margin-bottom: 5px;
		}

		ol, ul {
			margin: 10px 0 10px 0;
			list-style-position: inside;
		}

		p {
			margin: 5px 0 5px 0;
		}

		.content {
			border: 1px dotted #444;
			margin: 10px;
			padding: 10px;
			text-align: justify;
			width: 700px;
		}

		.example {
			border: 1px solid #ccc;
			background: #eee;
			margin: 10px;
			padding: 10px;
		}
	</style>
</head>

<body>
	<div class="content">
		<h1>Creating Your Own Libraries</h1>

		<p>Libraries in CarbonPHP are simply PHP classes stored in the <b>carbon/libraries/</b> directory.  We will
		tell you how to create your own CarbonPHP libraries within the <b>application/libraries/</b> directory.
		This allows you to keep your libraries and the CarbonPHP libraries separate.</p>

		<p>CarbonPHP also allows you to extend the CarbonPHP libraries with your own libraries allowing you to add
		functionality to the existing libraries.  You can even replace existing libraries with your own.</p>

		<p><i>Note</i>: you cannot replace or extend the CarbonPHP database classes.  Every other library can be
		replaced or extended.</p>
	</div>

	<div class="content">
		<h1>Storing Your Libraries</h1>

		<p>As desribed above you should place your own libraries in the <b>application/libraries/</b> directory.
		This is the first directory that CarbonPHP looks in for loading libraries.</p>
	</div>

	<div class="content">
		<h1>Naming Your Libraries</h1>

		<p>File names for your libraries should be capitalised, like <b>Mylibrary.php</b>.  Class declarations must
		be capitalised just like file names, <b>class Myclass</b>.  Class names and file names must match.</p>
	</div>

	<div class="content">
		<h1>Class File Skeleton</h1>

		<p>Classes for libraries should have the basic skeleton, the name <b>Some_library</b> is an example.</p>

		<div class="example">
			&lt;?php<br />
			<br />
			if (!defined('CARBON_PATH'))<br />
			&#123;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;exit('Direct script access is not allowed.');<br />
			&#125;<br />
			<br />
			class Some_library<br />
			&#123;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;public function some_function()<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&#123;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&#125;<br />
			&#125;<br />
			<br />
			?&gt;
		</div>
	</div>

	<div class="content">
		<h1>Using Your Libraries</h1>

		<p>As with any other library, you can load your library the same way within your controllers.</p>

		<div class="example">
			$this->load->library('<b>some_library</b>');
		</div>

		<p>Where <b>some_library</b> is the name of your library.  You can use the capitalised and lower case name,
		CarbonPHP can use either.  Once you have loaded your library you can use it by accessing it the same way
		as any other library.</p>

		<div class="example">
			$this-><b>some_library</b>->some_function();
		</div>
	</div>

	<div class="content">
		<h1>Passing Parameters When Initialising Your Library</h1>

		<p>When you load a library you can pass data via the second parameter and it will be passed to the constructor
		of the library class.</p>

		<div class="example">
			$params = array('Color' => 'Red', 'Size' => 'Small');<br />
			<br />
			$this->load->library('Some_library, <b>$params</b>);
		</div>

		<p>When you do this, you will have to create your constructor so that the constructor expects data to be
		passed to it.</p>

		<div class="example">
			&lt;?php<br />
			<br />
			if (!defined('CARBON_PATH'))<br />
			&#123;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;exit('Direct script access is not allowed.');<br />
			&#125;<br />
			<br />
			class Some_library<br />
			&#123;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;public function __construct($params)<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&#123;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;// Use the $params variable<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&#125;<br />
			&#125;<br />
			<br />
			?&gt;
		</div>

		<p><i>Note</i>: you are able to pass parameters stored in a configuration file.  You can simply create the
		configuration file stored in <b>application/config/</b> directory.  The configuration file must be identically
		to the library.  If you pass data as described above, this option is not available to you.</p>
	</div>

	<div class="content">
		<h1>Using CarbonPHP Resources in Your Library</h1>

		<p>You can access the resources in CarbonPHP by calling the <b>get_instance()</b> function.  This function
		returns the CarbonPHP object.  Usually within your controller methods you can access the <b>$this</b>
		variable.</p>

		<div class="example">
			<b>$this</b>->load->utility('form');<br />
			<b>$this</b>->load->library('pagination');<br />
			<b>$this</b>->config->get_item_value('base_url');
		</div>

		<p>The <b>$this</b> variable is only available within your controllers, models, and views.  If you would like
		to access CarbonPHP's libraries and classes within your own library you must do the following.</p>

		<div class="example">
			$carbon =&amp; get_instance();
		</div>

		<p>Once the object has been assigned to a variable, you can use that variable instead of the <b>$this</b>
		variable.</p>

		<div class="example">
			$carbon =&amp; get_instance();<br />
			<br />
			<b>$carbon</b>->load->utility('form');<br />
			<b>$carbon</b>->load->library('pagination');<br />
			<b>$carbon</b>->config->get_item_value('base_url');
		</div>

		<p><i>Note</i>: please note that when <b>get_instance()</b> is being passed by reference.  This is important
		because assigning by reference means you use the original CarbonPHP object instead of creating a copy of it.</p>
	</div>

	<div class="content">
		<h1>Replacing CarbonPHP Libraries</h1>

		<p>To simply replace the CarbonPHP libraries you just need to name your library the exact same.  This will make
		CarbonPHP use that library instead of the CarbonPHP one.  For example if you were going to replace the
		pagination library, you will create the file <b>application/libraries/Pagination.php</b> and declare the class
		as the following.</p>

		<div class="example">
			&lt;?php<br />
			<br />
			if (!defined('CARBON_PATH'))<br />
			&#123;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;exit('Direct script access is not allowed.');<br />
			&#125;<br />
			<br />
			class Carbon_Pagination<br />
			&#123;<br />
			<br />
			&#125;<br />
			<br />
			?&gt;
		</div>

		<p><i>Note</i>: CarbonPHP classes are prefixed with <b>Carbon_</b> and classes you intend to replace them with
		must follow this as well.</p>

		<p>To load your library you use the same standard method of loading libraries.</p>

		<div class="example">
			$this->load->library('<b>pagination</b>');
		</div>

		<p><b>Note</b>: as previously stated, database classes cannot be replaced.</p>
	</div>

	<div class="content">
		<h1>Extending CarbonPHP Libraries</h1>

		<p>If you only want to add a little functionality to an existing CarbonPHP library, then maybe adding one
		or two methods, then it's overkill to fully replace the CarbonPHP library.  It is better in this case to
		extend the existing library.  To extend a library it is nearly exactly the same as replacing a library, minus
		some differences.</p>

		<ul>
			<li>The class declaration must extend the parent class.</li>
			<li>The new class name and file name must be prefixed with the subclass prefix.</li>
		</ul>

		<p>The subclass prefix is configurable in the configuration file.  For example if we were going to extend the
		pagination library, we would create the file <b>application/libraries/Sub_Pagination.php</b> and declare the
		class as below.</p>

		<div class="example">
			&lt;?php<br />
			<br />
			if (!defined('CARBON_PATH'))<br />
			&#123;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;exit('Direct script access is not allowed.');<br />
			&#125;<br />
			<br />
			class Sub_Pagination extends Carbon_Pagination<br />
			&#123;<br />
			<br />
			&#125;<br />
			<br />
			?&gt;
		</div>

		<p><i>Note</i>: if you decide to use a constructor in your subclass you must remember to call the parent
		classes constructor.</p>

		<div class="example">
			&lt;?php<br />
			<br />
			if (!defined('CARBON_PATH'))<br />
			&#123;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;exit('Direct script access is not allowed.');<br />
			&#125;<br />
			<br />
			class Sub_Pagination extends Carbon_Pagination<br />
			&#123;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;public function __construct()<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&#123;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;parent::__construct();<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&#125;<br />
			&#125;<br />
			<br />
			?&gt;
		</div>

		<p>To load your subclass you use the standard method of loading libraries.  Although you do <b>not</b> include
		the prefix in the name when loading.</p>

		<div class="example">
			$this->load->library('<b>pagination</b>');
		</div>

		<p>Once the library is loaded you can access it as you would normally.  The extended methods will be available
		to you for calling.</p>

		<div class="example">
			$this-><b>pagination</b>->new_function();
		</div>

		<p>You can set your own subclass prefix in the configuration file <b>application/config/config.php</b> and
		edit the <b>subclass_prefix</b> value.</p>

		<div class="example">
			$config['subclass_prefix'] = 'Sub_';
		</div>
	</div>
</body>

</html>
